package com.school.project.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sun.istack.NotNull;
import lombok.*;
import org.hibernate.annotations.Fetch;

import javax.persistence.*;
import java.util.List;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@RequiredArgsConstructor
@Entity
@Table(name = "assessment_type")
public class AssessmentType {

    public static enum TYPES {
        ASSIGNMENT,
        QUIZ,
        MIDTERM,
        FINAL,
        PROJECT,
        PRESENTATION,
        REPORT,
        PARTICIPATION,
        LABWORK,
        LABTASK,
    }

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "assessment_id")
    private Long assessmentId;

    @NotNull
    @Column(name = "assessment_name")
    private String assessmentName;

    @ManyToMany(fetch = FetchType.LAZY, mappedBy = "assessmentType")
    @JsonIgnore
    private List<Grade> gradeAssessment;
}
