package com.school.project.model;


import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sun.istack.NotNull;
import lombok.*;

import javax.persistence.*;
import java.util.List;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@RequiredArgsConstructor
@Entity
@Table(name = "grade")
public class Grade {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "grade_id")
    private Long gradeId;


    @NotNull
    @Column(name = "assessment_number")
    private Long assessmentNumber;

    @ManyToMany(fetch = FetchType.LAZY,cascade = CascadeType.MERGE)
    @JoinTable(name = "assessment_grade_type",
            joinColumns = {@JoinColumn(name = "grade_id")},
            inverseJoinColumns = {@JoinColumn(name = "assessment_id")}
    )
    @JsonIgnore
    @NotNull
    private List<AssessmentType> assessmentType;

    @ManyToMany(fetch = FetchType.LAZY,cascade = CascadeType.ALL)
    @JoinTable(name = "student_grade",
            joinColumns = {@JoinColumn(name = "grade_id")},
            inverseJoinColumns = {@JoinColumn(name = "student_id")}
    )
    @JsonIgnore
    @NotNull
    private List<Student> studentGrades;

    @ManyToMany(fetch = FetchType.LAZY,cascade = CascadeType.ALL)
    @JoinTable(name = "course_grade",
            joinColumns = {@JoinColumn(name = "grade_id")},
            inverseJoinColumns = {@JoinColumn(name = "course_id")}
    )
    @JsonIgnore
    @NotNull
    private List<Course> courseGrades;

    @Column(name = "weightage")
    @NotNull
    private Long weightage;

    @Column(name = "total_marks")
    @NotNull
    private Long totalMarks;

    @Column(name = "obtained_marks")
    @NotNull
    private Long obtainedMarks;

}
