package com.school.project.service.teacher;

import com.school.project.dto.teacher.TeacherUploadStudentMarksDTO;
import com.school.project.mapper.SingleCourseToListOfCourseMapper;
import com.school.project.mapper.SingleStudentToListOfStudentMapper;
import com.school.project.model.Grade;
import com.school.project.repository.AssessmentTypeRepository;
import com.school.project.repository.CourseRepository;
import com.school.project.repository.GradeRepository;
import com.school.project.repository.StudentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;

@Service
public class UploadMarksServiceImpl implements UploadMarksService {

    @Autowired
    AssessmentTypeRepository assessmentTypeRepository;

    @Autowired
    GradeRepository gradeRepository;

    @Autowired
    StudentRepository studentRepository;

    @Autowired
    CourseRepository courseRepository;

    @Autowired
    SingleStudentToListOfStudentMapper studentMapper;

    @Autowired
    SingleCourseToListOfCourseMapper courseMapper;

    @Override
    @Transactional
    public void uploadStudentMarks(TeacherUploadStudentMarksDTO studentAndMarks) {
        Grade studentGrade = new Grade();

        studentGrade.setAssessmentNumber(studentAndMarks.getAssessmentNumber());

        studentGrade.setAssessmentType(assessmentTypeRepository.findByAssessmentName(
                studentAndMarks.getAssessmentType()));

        studentGrade.setStudentGrades(studentMapper.modelToList(
                studentRepository.findByRollNumber(
                        studentAndMarks.getStudentRollNumber())));

        studentGrade.setCourseGrades(courseMapper.modelToList(
                courseRepository.findByCourseName(
                        studentAndMarks.getCourseName())));

        studentGrade.setWeightage(studentAndMarks.getWeightage());
        studentGrade.setTotalMarks(studentAndMarks.getTotalMarks());
        studentGrade.setObtainedMarks(studentAndMarks.getObtainedMarks());

        gradeRepository.save(studentGrade);

    }
}
